//import processing.opengl.*;
import java.awt.datatransfer.*;
import  netscape.javascript.*;

int fileNum = 0;
float myScale = 0.999; float myLeft = 0; float myTop = 0;


ArrayList beziers;
ArrayList beziersUndo;
CopyPaste copypaste;
Iterator it;
char pleaseCall = '_';
int selPoint;


void setup(){
  size(480,320);//,OPENGL);
  //hint(ENABLE_OPENGL_2X_SMOOTH);
  
  frameRate(20);
  smooth();
 
  beziers = new ArrayList(0);
  copypaste = new CopyPaste();
  
  noFill();
  putTitle("Bezienne! | Default-drawing - 0"); 
  
  //Autoload last file
  openDrw(true);
  
  //THE ONLY EASY WAY I FOUND TO GET THE CENTRAL WHEEL WORK
  this.addMouseWheelListener(new MouseWheelInput());
}


void draw(){
  background(#FFFFFF);
  
  scale(myScale);
  translate(myLeft,myTop);
  
  stroke(#FF0000);
  strokeWeight(1);
  line(10,5,30,5);
  stroke(#006633);
  line(5,10,5,30);
  stroke(#000000);

  rect(0,0,width,height);

  it = beziers.iterator();
  while (it.hasNext ()) {
    
    Bez b = (Bez)it.next (); 
    
    
     if(b.isSel()){
       if(b.isReady()){
       stroke(#FF3333);
       strokeWeight(2);
       b.drawMe();
       strokeWeight(1);
       b.drawCPoints();
       }else{
       stroke(#FF3333);
       strokeWeight(1);
       b.drawConstruction();
       }
     }else{
       stroke(#000000);
       strokeWeight(2);
       b.drawMe();
    }
 }
 
 if(pleaseCall!='_'){
    keyPressed();
 }
}


void switchSelAll(){
  it = beziers.iterator();
  while (it.hasNext ()) {
    Bez b = (Bez)it.next ();  b.sel(!b.isSel());
  }
}

void selFirst(){
  if(!beziers.isEmpty()){
    Bez b = (Bez) beziers.get(0);
    b.sel(!b.isSel());
    }
}

public void selLast(){
  if(!beziers.isEmpty()){
    Bez b = (Bez) beziers.get(beziers.size()-1);
    b.sel(!b.isSel());
    }
}

void moveAll(float x, float y){
  Iterator it = beziers.iterator();
  while (it.hasNext ()){
    Bez o = (Bez)it.next();
    if(!o.isSel()){ continue; }
    
    Iterator pIt = o.p.iterator();
    while (pIt.hasNext ()){
       CP p = (CP)pIt.next();
       
       p.x = p.x+x;
       p.y = p.y+y;
    }
}
}

void scaleAll(float s){
  Iterator it = beziers.iterator();
  while (it.hasNext ()){
    Bez o = (Bez)it.next();
    if(!o.isSel()){ continue; }
    
    Iterator pIt = o.p.iterator();
    while (pIt.hasNext ()){
       CP p = (CP)pIt.next();
       
       p.x = p.x*s;
       p.y = p.y*s;
    }
}}

void mirrorAll(float v,float h){
  Iterator it = beziers.iterator();
  while (it.hasNext ()){
    Bez o = (Bez)it.next();
    if(!o.isSel()){ continue; }
    
    Iterator pIt = o.p.iterator();
    while (pIt.hasNext ()){
       CP p = (CP)pIt.next();
       
       p.x = p.x*v+((v==-1)?width:0);
       p.y = p.y*h+((h==-1)?height:0);
    }
}}

void selAllNone(){

  if(beziers.size()>0){
    it = beziers.iterator();
    Bez b;
    b = (Bez)beziers.get(0);
    boolean v = b.isSel();
    
  while (it.hasNext ()) {
    b = (Bez)it.next ();  b.sel(!v);
  }}
}

void unSelAll(){
  it = beziers.iterator();
  while (it.hasNext ()) {
    Bez b = (Bez)it.next ();  b.sel(false);
  }
}

void deleteSel(){
  beziersUndo = (ArrayList)beziers.clone();
  boolean someThingHappened = false;
  it = beziers.iterator();
  while (it.hasNext ()) {
    Bez b = (Bez)it.next ();
    if(b.isSel()){
      it.remove();
      someThingHappened = true;
    }
  }
  if(beziers.isEmpty()){
       println("Nothing to delete!");
  } else if(!someThingHappened){
       it.remove();
  }
}

void selOnlyNext(){
  it = beziers.iterator();
  boolean exeption = false;
  while (it.hasNext ()) {
    Bez b = (Bez)it.next(); 
    if(exeption){
       b.sel(false);
    }else if(b.isSel()){
          if(it.hasNext()){
                 Bez c = (Bez)it.next();
                 c.sel(true);
                 if(!(keyPressed && key==CODED && keyCode==SHIFT))
                    b.sel(false);
                 exeption = true;
          }else{
                 b.sel(false);
                 println("All unselected.");
          }
    }
  }
}

void selOnlyPrev(){
  it = beziers.iterator();
  int count = 0;
  boolean exeption = false;
  while (it.hasNext ()) {
    Bez b = (Bez)it.next();
    if(exeption){
         b.sel(false);
    }else if(b.isSel()){
          if(count==0){
                 b.sel(false);
                 exeption = true;
                 println("All unselected.");
          }else{
                 Bez c = (Bez)beziers.get(count-1);
                 b.sel(false);
                 c.sel(true);
          }
    }
    count++;
  }
}

void deleteOneInput(){
       if(!beziers.isEmpty()){
          Bez b = (Bez) beziers.get(beziers.size()-1);
          b.removeDetail();
          b.sel(true);
       }else{
          println("No control points to delete!");
       }
}

void undoLast(){
  ArrayList a = beziers;
  beziers = beziersUndo;
  beziersUndo = a;
}

void approximateDrawing(){
  Iterator it = beziers.iterator();
  while (it.hasNext ()){
    Bez o = (Bez)it.next();
    
    Iterator pIt = o.p.iterator();
    while (pIt.hasNext ()){
       CP p = (CP)pIt.next();
       
       p.x = round(p.x);
       p.y = round(p.y);
    }
}}

void putTitle(String s){
   try{
   JSObject win = JSObject.getWindow(this);  //Not possible offline
   JSObject doc = (JSObject) win.getMember("document");
   doc.setMember("title",s);
   } catch (Exception e){
    frame.setTitle(s); //Not possible online
   }
}
